import 'package:flutter/material.dart';
import 'package:supa_test/product.dart';

import 'ads_icon_detail.dart';

class AdsDetail extends StatelessWidget {
 Product product;


 AdsDetail(this.product);

  @override
  Widget build(BuildContext context) {
    return Scaffold(
      appBar: AppBar(
        leading: IconButton(
          icon: Icon(Icons.arrow_back_ios,color: Colors.black),
          iconSize: 20.0,
          onPressed: () {
           Navigator.pop(context);
          },
        ),
        backgroundColor: Colors.white,
        centerTitle: true,
        title: Text("دیوار", style: TextStyle(fontFamily: 'Dana',color: Colors.black),),
      ),
      body: Container(
        color: Color(0xfffafafa),
        child: ListView(
          children: [
            Container(
              width: MediaQuery.of(context).size.width,
              height: 150.0,
              child: Image.network(product.image!,fit: BoxFit.fill,),

            ),
            Container(
              margin: EdgeInsets.symmetric(horizontal: 6.0,vertical: 7.0),
              child: Card(
                color: Colors.white,
                elevation: 1.0,
                child: Column(
                  children: [
                    Container(
                      alignment: Alignment.topRight,
                      margin: EdgeInsets.symmetric(horizontal: 8.0,vertical: 7.0),
                      child:  Text(product.title!,textAlign: TextAlign.right,style:
                      TextStyle(fontFamily: 'Dana',color: Colors.black,fontSize: 20.0),
                    )
                    ),
                    Container(
                        alignment: Alignment.topRight,
                        margin: EdgeInsets.symmetric(horizontal: 8.0,vertical: 5.0),
                        child:  Row(
                          mainAxisAlignment: MainAxisAlignment.end,
                          children: [
                            Text(" ${product.price.toString()} \$ ",textAlign: TextAlign.right,
                                style: TextStyle(fontFamily: 'Dana',color: Colors.black,fontSize: 22.0)),
                            SizedBox(width: 10.0,),
                            Text(":قیمت",textAlign: TextAlign.right,style:
                            TextStyle(fontFamily: 'Dana',color: Colors.black,fontSize: 20.0)),
                          ],
                        )
                    ),
                    Container(
                      margin: EdgeInsets.symmetric(horizontal: 8.0,vertical: 10.0),
                      child: Row(
                        mainAxisAlignment: MainAxisAlignment.spaceEvenly,
                        children: [
                          AdsIconDetail(product.city!,Icon(Icons.location_on_outlined,color: Color(0xffe9e9e9))),
                          AdsIconDetail(product.category!,Icon(Icons.folder_special_outlined,color:Color(0xffe9e9e9)))
                        ],
                      ),
                    ),
                    SizedBox(height: 15.0,),
                  ],
                ),
              ),
            ),
      Container(
        margin: EdgeInsets.symmetric(horizontal: 6.0,vertical: 7.0),
        child: Card(
          color: Colors.white,
          elevation: 1.0,
          child: Column(
            children: [
              Container(
                  alignment: Alignment.topRight,
                  margin: EdgeInsets.symmetric(horizontal: 8.0,vertical: 7.0),
                  child: Text("خلاصه آگهی",style: TextStyle(fontFamily: 'Dana',color: Colors.black,fontSize: 22.0))
              ),
              Container(
                  alignment: Alignment.topRight,
                  margin: EdgeInsets.symmetric(horizontal: 8.0,vertical: 7.0),
                  child: Text(product.desc!,textAlign: TextAlign.right,style:
                  TextStyle(fontFamily: 'Dana',color: Colors.black,fontSize: 16.0))
              )
            ],
          ),
        )
      )
          ],
        ),
      ),
    );
  }
}
