import 'package:flutter/material.dart';
import 'package:supa_test/ads_detail.dart';
import 'package:supa_test/ads_item.dart';
import 'package:supa_test/product.dart';
import 'package:supa_test/send_ads.dart';
import 'package:supabase/supabase.dart';
import 'package:supabase_flutter/supabase_flutter.dart';

class AdsList extends StatefulWidget {
  const AdsList({Key? key}) : super(key: key);

  @override
  State<AdsList> createState() => _AdsListState();
}

class _AdsListState extends State<AdsList> {


  final SupabaseClient supabase = Supabase.instance.client;
  late Stream<List<Map<String,dynamic>>> _readStream;

  @override
  void initState() {
    // TODO: implement initState
    _readStream = supabase.from('ads').stream(primaryKey: ['id']);
    _readStream.listen((event) { });

    super.initState();
  }

  Future<dynamic> getData() async{
    final Future<dynamic> _future = supabase
        .from('ads')
        .select()
        .order('id',ascending: true);
    return _future;
  }
  @override
  Widget build(BuildContext context) {
    return Scaffold(
      appBar: AppBar(
        backgroundColor: Colors.white,
          centerTitle: true,
        title: Text('آگهی ها',style: TextStyle(fontFamily: 'Dana',color: Colors.black),),
        actions: [
          IconButton(onPressed: (){
            Navigator.push(context, MaterialPageRoute(builder: (context) => SendAds(),));
          },
              icon: Icon(Icons.add,color: Colors.black,)
          )
        ],
      ),
      body: Container(
        color: Color(0xffafafa),
        child: FutureBuilder(
          future: getData(),
          builder: (context, snapshot) {

            if(snapshot.hasData){
              Iterable _iterable = snapshot.data;
              var _list = _iterable.map((e) => Product.fromJson(e)).toList();
              print(_iterable.toString());
              return ListView.builder(
                itemCount: _iterable.length,
                  itemBuilder: (context, index) {
                    return InkWell(
                      onTap: (){
                        Navigator.push(context, MaterialPageRoute(builder: (context) => AdsDetail(_list[index]),));

                      },
                      child: AdsItem(_list[index]),
                    );
                  },
              );
            }else if(snapshot.hasError){
              return Center(child: Text("error: ${snapshot.error}"),);
            }else{
              return Center(child: Text("Loading...."),);
            }
          },
        ),
      ),
    );
  }
}
