import 'package:flutter/material.dart';
import 'package:supa_test/text_input.dart';
import 'package:supabase/supabase.dart';
import 'package:supabase_flutter/supabase_flutter.dart';

class AuthPage extends StatefulWidget {
  const AuthPage({Key? key}) : super(key: key);

  @override
  State<AuthPage> createState() => _AuthPageState();
}

class _AuthPageState extends State<AuthPage> {

  final SupabaseClient supabase = Supabase.instance.client;
  bool _signinLoading = false;
  bool _signUpLoading = false;

  final _email_controller = TextEditingController();
  final _passwodrd_controller = TextEditingController();
  final _formKey = GlobalKey<FormState>();

  @override
  void dispose() {

   supabase.dispose();
    _email_controller.dispose();
    _passwodrd_controller.dispose();
    super.dispose();
  }
  @override
  void initState() {

  }

  @override
  Widget build(BuildContext context) {
    return Scaffold(
      body: Center(
        child: SingleChildScrollView(
          child: Form(
            key: _formKey,
            child: Padding(
              padding: EdgeInsets.all(20.0),

              child: Column(
                mainAxisAlignment: MainAxisAlignment.center,
                crossAxisAlignment: CrossAxisAlignment.stretch,
                children: [
                  Container(
                      alignment: Alignment.center,
                      child: Text("خوش آمدید",style: TextStyle(fontSize: 25.0,fontFamily: 'Dana'),)),
                  SizedBox(height: 30.0,),
                  TextInput(hint: 'ایمیل',controller: _email_controller,),
                  TextInput(hint: 'رمز عبور',controller: _passwodrd_controller,ispassword: true,),
                  SizedBox(height: 20.0,),
                  /*
                  login button
                   */
                  _signinLoading ? const Center(child: CircularProgressIndicator(),):
                  ElevatedButton(onPressed: ()async{
                    setState(() {
                      _signinLoading = true;
                    });
                    try{

                     await supabase.auth.signInWithPassword(email: _email_controller.text,password: _passwodrd_controller.text);
                    }catch(e){
                      ScaffoldMessenger.of(context).showSnackBar( SnackBar(content: Text("error: ${e.toString()}"),
                      backgroundColor: Colors.redAccent,));
                      setState(() {
                        _signinLoading = false;
                      });
                    }
                  },

                      child: Text("Login")
                  ),
                  /*
                  sing up button
                   */
                  _signUpLoading ? const Center(child: CircularProgressIndicator(),):
                  OutlinedButton(onPressed: ()async{
                    setState(() {
                      _signUpLoading = true;
                    });
                    try{

                     await supabase.auth.signUp(email: _email_controller.text,password: _passwodrd_controller.text);
                      ScaffoldMessenger.of(context).showSnackBar( SnackBar(content: Text("لینک تایید ارسال شد"),
                        backgroundColor: Colors.greenAccent,));
                     setState(() {
                       _signUpLoading = false;
                     });
                    }catch(e){
                      ScaffoldMessenger.of(context).showSnackBar( SnackBar(content: Text("error: ${e.toString()}"),
                        backgroundColor: Colors.redAccent,));
                      setState(() {
                        _signUpLoading = false;
                      });
                    }
                  },

                      child: Text("Sign up")
                  )
                ],
              ),
            ),
          ),
        ),
      ),
    );
  }


}
