import 'dart:convert';

import 'package:flutter/material.dart';
import 'package:supa_test/ads_detail.dart';
import 'package:supa_test/pages/ads_item.dart';
import 'package:supa_test/pages/send_ads.dart';
import 'package:supabase/supabase.dart';
import 'package:supabase_flutter/supabase_flutter.dart';

import '../product.dart';

class AdsList extends StatefulWidget {
  const AdsList({Key? key}) : super(key: key);

  @override
  State<AdsList> createState() => _AdsListState();
}

class _AdsListState extends State<AdsList> {
  final SupabaseClient supabase = Supabase.instance.client;
  late Stream<List<Map<String,dynamic>>> _readStream;


  @override
  void initState() {
    _readStream = supabase.from('ads').stream(primaryKey: ['id']);
    //_readStream = supabase.from('ads').stream(primaryKey: ['id']);
   // print(_readStream.first.toString());
    super.initState();
    // final Future<dynamic> _future = supabase
    //     .from('ads')
    //     .select()
    //     .order('name', ascending: true);

    _readStream.listen((event) {
      // print("Event: ");
      //print(event.toString());
    });
  }
  Future<dynamic> getData()async{
    final Future<dynamic> _future = supabase
        .from('ads')
        .select()
        .order('id', ascending: true);
    return _future;
  }
  @override
  Widget build(BuildContext context) {
    return Scaffold(

      appBar:  AppBar(
        backgroundColor: Colors.white,
        centerTitle: true,
        title: Text("دیوار", style: TextStyle(fontFamily: 'Dana',color: Colors.black),),
        actions: [
          IconButton(onPressed: (){
            Navigator.push(context, MaterialPageRoute(builder: (context)=>SendAds()));

          },
              icon: Icon(Icons.add,color: Colors.black)

          ),
        ],
      ),
      body: Container(
        color: Color(0xfffafafa),
        child:  FutureBuilder(
          future: getData(),
          builder: (context, snapshot) {
            if(snapshot.hasData){

              var temp = jsonEncode(snapshot.data);
            //  Iterable iterable = [jsonDecode(temp)];
              Iterable iterable = jsonDecode(temp);
              print(temp);
              print("--------------");
          //    print(iterable.toString());
            // iterable.map((e) {
            //   print("--------------");
            //   print(e.toString());
            // },);
              var sh = iterable.map((e) => Product.fromJson(e)).toList();
              print(sh[0].title);
           //  Product pr = Product.fromJson(iterable.first);
            // print("------ ${pr.title}");
              //return Center(child: Text("ok"),);
              return ListView.builder(
                  itemCount: iterable.length,
                  itemBuilder: (context,int index){
                   // var data = snapshot.data[index];
                   //  print("---- data");
                   //  print(json.decode(data));
                   //  print("----");
                   //  Product pr = Product.fromJson(snapshot.data[index]  as Map<String, dynamic>);// {} map
                 //   Product pr = Product.fromJson(iterable.elementAt(index));
                    return InkWell(
                      onTap: (){
                        Navigator.push(context, MaterialPageRoute(builder: (context)=>AdsDetail(sh[index])));
                      },
                      child: Adsitem(sh[index]),
                    );

                  });


            }else if(snapshot.hasError){
              return Center(child: Text("error ${snapshot.error}"),);

            }else{
              return Center(child: Text("loading"),);
            }
          },
        )


      ),
    );
  }
}
