import 'package:flutter/material.dart';

class TextInput extends StatelessWidget {
  TextEditingController? textEditingController;
  String? hint;

  TextInput(this.textEditingController, this.hint);

  @override
  Widget build(BuildContext context) {
    return Container(
      margin: EdgeInsets.symmetric(horizontal: 10.0,vertical: 7.0),
      padding: EdgeInsets.symmetric(horizontal: 4.0,vertical: 1.0),
      alignment: Alignment.topRight,
      decoration: BoxDecoration(
        borderRadius: BorderRadius.all(Radius.circular(7.0)),
          color: Colors.white,
        boxShadow: [
          BoxShadow(
            offset: Offset(0, 1),
            blurRadius: 5,
            color: Colors.black.withOpacity(0.1),
          ),
        ],
      ),

      child: TextField(
        textAlign: TextAlign.end,
        style: TextStyle(fontFamily: 'Dana',fontSize: 17.0),
        controller: textEditingController,
        decoration: InputDecoration(
          focusedBorder: InputBorder.none,
          enabledBorder: InputBorder.none,
          hintText: hint,
          hintStyle: TextStyle(fontFamily: 'Dana',fontSize: 17.0)
        ),

      ),

    );
  }
}
