import 'dart:io';
import 'dart:math';

import 'package:flutter/material.dart';
import 'package:supa_test/text_input.dart';
import 'package:supabase_flutter/supabase_flutter.dart';
import 'package:file_picker/file_picker.dart';
class SendAds extends StatefulWidget {
  const SendAds({Key? key}) : super(key: key);

  @override
  State<SendAds> createState() => _SendAdsState();
}

class _SendAdsState extends State<SendAds> {

  bool _isUPloading = false;
  final SupabaseClient supabase = Supabase.instance.client;
  TextEditingController title_controller = TextEditingController();
  TextEditingController desc_controller = TextEditingController();
  TextEditingController price_controller = TextEditingController();

  List<String> cat_list = ["خانه","ماشین","موبایل"];
  List<String> city_list = ["تهران","رشت","قشم"];

  String city_value = "تهران";
  String cat_value = "خانه";


  Future<String?> uploadFile() async{


    var pickedfile = await FilePicker.platform.pickFiles(allowMultiple: false,type: FileType.image);
    if(pickedfile!=null){
      setState(() {
        _isUPloading = true;
      });
      ///  D:/id1/f0.png
      ///  D:/id1/f1.png
      ///  D:/id2/f.png
      try{
      //  https://yuimzptrjihrqqzuibkh.supabase.co/storage/v1/object/public/user-images/test/p1.jpg
        var file_path = "https://yuimzptrjihrqqzuibkh.supabase.co/storage/v1/object/public/";
        File file = File(pickedfile.files.first.path!);
        String filename = pickedfile.files.first.name;
        String uploadfile = await supabase.storage.from('user-images').upload("${supabase.auth.currentUser!.id}/$filename", file);
       String file_url = await supabase.storage.from('user-images').getPublicUrl("${supabase.auth.currentUser!.id}/$filename");
     // String file_url = file_path+uploadfile;
        print(uploadfile);
      print(file_url);
      return file_url;
      }catch(e){
          print("Error: ${e.toString()}");
          setState(() {
            _isUPloading = false;
          });
          ScaffoldMessenger.of(context).showSnackBar( SnackBar(content: Text("error: ${e.toString()}"),
            backgroundColor: Colors.redAccent,));
      }


    }
  }


  Future insertData() async {
    String? img_url  = await uploadFile();


    try{
      String userId = supabase.auth.currentUser!.id;
      await supabase.from('ads').insert({
        'userid': userId,
        'title': title_controller.text,
        'desc': desc_controller.text,
        'city': city_value,
        'category': city_value,
        "img":img_url,
        "price": int.parse(price_controller.text)
      });
      ScaffoldMessenger.of(context).showSnackBar( SnackBar(content: Text("اطلاعات ثبت شد"),
        backgroundColor: Colors.greenAccent,));
      setState(() {
        _isUPloading = false;
      });
    }catch(e){
      print("Error: ${e.toString()}");
      setState(() {
        _isUPloading = false;
      });
      ScaffoldMessenger.of(context).showSnackBar( SnackBar(content: Text("error: ${e.toString()}"),
        backgroundColor: Colors.redAccent,));
    }
  }

  @override
  void initState() {
    // TODO: implement initState
    cat_value = cat_list[0];
    city_value = city_list[0];
  }



  @override
  Widget build(BuildContext context) {
    return Scaffold(
      floatingActionButton: _isUPloading? const CircularProgressIndicator(): FloatingActionButton(
        child: Icon(Icons.access_alarm_outlined),onPressed: (){},),
      appBar: AppBar(
        backgroundColor: Colors.white,
        title: Text("ثبت آگهی",style: TextStyle(fontFamily: 'Dana',color: Colors.black),),
      ),
      body: Container(
        color: Color(0xffafafa),
        child: Column(
          children: [
            TextInput(controller: title_controller,hint: 'عنوان',),
            TextInput(controller: desc_controller,hint: 'توضیحات',),
            TextInput(controller: price_controller,hint: 'قیمت',),
            Row(
              mainAxisAlignment: MainAxisAlignment.spaceAround,
              children: [

                DropdownButton<String>(
                  onChanged: (String? newValue){
                    setState(() {
                      city_value = newValue!;
                    });
                  },
                  value: city_value,
                  items: city_list.map<DropdownMenuItem<String>>((e) => DropdownMenuItem<String>(
                    value: e,
                    child: Text(e.toString(),style: TextStyle(fontFamily: 'Dana'),),
                  )).toList()
                ),
                DropdownButton<String>(
                    onChanged: (String? newValue){
                      setState(() {
                        cat_value = newValue!;
                      });
                    },
                    value: cat_value,
                    items: cat_list.map<DropdownMenuItem<String>>((e) => DropdownMenuItem<String>(
                      value: e,
                      child: Text(e.toString(),style: TextStyle(fontFamily: 'Dana'),),
                    )).toList()
                )
              ],
            ),
            Container(
              margin: EdgeInsets.symmetric(vertical: 15.0),
              child: ElevatedButton(
                child: Text('انتخاب تصویر',style: TextStyle(fontFamily: 'Dana')),
                onPressed: () async{
                  insertData();
                },
              ),
            )
          ],
        ),
      ),
    );
  }
}
